/*
  simple control gui for a TimerDevice
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __GUITIMERDEVICE_H
#define __GUITIMERDEVICE_H

#include <qpainter.h>
#include <qpushbt.h>
#include <qtimer.h> 


#include <devices/timerDevice.h>
#include <yafcore/buffer.h>

#include <deviceWidgets/guiDevice.h>




class GuiTimerDevice : public GuiDevice {
  Q_OBJECT

  TimerDevice* timerDevice;

 public:
  GuiTimerDevice( QWidget *parent=0, const char *name=0 );
  ~GuiTimerDevice();

  // usefull timer functions:
  float getTime();



  // for the default gui:
  QSize sizeHint ();
  void paintEvent ( QPaintEvent * paintEvent );
 

 private:
    Buffer* buffer;
};


#endif
